package asm

import (
	"fmt"

	"git.urbach.dev/cli/q/src/cpu"
)

// RegisterNumber operates with a register and a number.
type RegisterNumber struct {
	Register cpu.Register
	Number   int
}

// String returns a human readable version.
func (data *RegisterNumber) String() string {
	return fmt.Sprintf("%s, %d", data.Register, data.Number)
}

// RegisterNumber adds an instruction with a register and a number.
func (a *Assembler) RegisterNumber(mnemonic Mnemonic, register cpu.Register, number int) {
	a.Instructions = append(a.Instructions, Instruction{
		Mnemonic: mnemonic,
		Type:     TypeRegisterNumber,
		Index:    Index(len(a.Param.RegisterNumber)),
	})

	a.Param.RegisterNumber = append(a.Param.RegisterNumber, RegisterNumber{
		Register: register,
		Number:   number,
	})
}
