package asm

import (
	"fmt"

	"git.urbach.dev/cli/q/src/cpu"
)

// RegisterRegister operates with two registers.
type RegisterRegister struct {
	Destination cpu.Register
	Source      cpu.Register
}

// String returns a human readable version.
func (data *RegisterRegister) String() string {
	return fmt.Sprintf("%s, %s", data.Destination, data.Source)
}

// RegisterRegister adds an instruction using two registers.
func (a *Assembler) RegisterRegister(mnemonic Mnemonic, left cpu.Register, right cpu.Register) {
	a.Instructions = append(a.Instructions, Instruction{
		Mnemonic: mnemonic,
		Type:     TypeRegisterRegister,
		Index:    Index(len(a.Param.RegisterRegister)),
	})

	a.Param.RegisterRegister = append(a.Param.RegisterRegister, RegisterRegister{
		Destination: left,
		Source:      right,
	})
}
